Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# deGlobalTypes.hpp File Reference

Basic datatype definitions (Destiny-wide scope). More...

`#include "deOS.hpp"`
`#include <cstring>`
`#include <cstdlib>`

Include dependency graph for deGlobalTypes.hpp:

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Compounds
struct | deAABB
struct | deBoundSphere
struct | deColor
struct | deFloatRect
struct | deLVert
struct | deOBB
struct | dePlane
struct | deRect
class | deRefCountBase
struct | deTexCoord1
struct | deTexCoord2
struct | deTexCoord3
struct | deTexCoord4
struct | deIDPair
class | IdeRefCountBase
| base reference-counting interface for all Destiny3D classes More...
struct | deVec3d
struct | deVec3f
## Defines
#define | _DEQUOTE(x) #x
#define | DESTRINGIZE_VALUE(x) _DEQUOTE(x)
#define | DE_DOUBLE_PRECISION (1)
#define | COS cos
#define | SIN sin
#define | TAN tan
#define | ACOS acos
#define | ASIN asin
#define | ATAN atan
#define | deTRUE (DE_TRUE)
#define | deFALSE (DE_FALSE)
#define | ARGB(a, r, g, b) ((DWORD)((((a)&0xff)<<24)|(((r)&0xff)<<16)|(((g)&0xff)<<8)|((b)&0xff)))
#define | GrabARGB(argb, a, r, g, b) {a=((argb>>24)&0xff); r=((argb>>16)&0xff); g=((argb>>8)&0xff); b=((argb)&0xff); }
#define | deXOR(x, y) ( (!(x)&&(y)) || ((x)&&!(y)) )
#define | max(a, b) (((a) > (b)) ? (a) : (b))
#define | min(a, b) (((a) < (b)) ? (a) : (b))
#define | LEAK_HUNTING
#define | FAR
#define | DETAILED_DEBUG_REPORT (1)
#define | NOTIFY_BAD_RETURNS (1)
#define | DEBUGMSG0(msg)
#define | DEBUGMSG1(fmt, arg1)
#define | DEBUGMSG2(fmt, arg1, arg2)
#define | DEBUGMSG3(fmt, arg1, arg2, arg3)
#define | DEBUGMSG4(fmt, arg1, arg2, arg3, arg4)
#define | DEBUGRETURN(retval, message) return retval
#define | DEBUGRETURNNOVAL(message) return
#define | DEBUG_EXP_RETURN(exp, retval)
#define | DEBUG_EXP_RETURNMSG(exp, retval, msg)
#define | DE_ASSERT(exp)
#define | DEBUG_ONLY(exp)
#define | DEG2RAD(d) ((d)*(DE_PI/180.0))
#define | RAD2DEG(r) ((r)*(180*DE_ONEOVERPI))
#define | DE3D_SAFE_DELETE(p) if(!p) {} else delete (p); (p)=NULL
#define | DE3D_SAFE_DELETE_ARRAY(p) if(!p) {} else delete[] (p); (p)=NULL
#define | DE3D_SAFE_RELEASE(p) if(!p) {} else (p)->Release(); (p)=NULL
#define | _TODO
#define | _PRINT_NOTES
#define | __DE_FILE__LINE__ __FILE__ "(" DESTRINGIZE_VALUE(__LINE__) "): "
#define | TODO(x)
#define | FIXME(x)
#define | note(x) message(__DE_FILE__LINE__ "NOTE: " #x "\n")
#define | todo(x) message(__DE_FILE__LINE__ "TODO: " #x "\n")
#define | fixme(x) message(__DE_FILE__LINE__ "FIXME: " #x "\n")
## Typedefs
typedef char | deBoolean
typedef float | deFloat
typedef double | deDouble
typedef unsigned long | deARGB
typedef unsigned short | deWorldID
typedef unsigned long | deObjectID
typedef unsigned long | DWORD
typedef int | BOOL
typedef unsigned char | BYTE
typedef unsigned short | WORD
typedef float | FLOAT
typedef FLOAT * | PFLOAT
typedef BOOL * | LPBOOL
typedef BYTE * | LPBYTE
typedef int * | LPINT
typedef WORD * | LPWORD
typedef long * | LPLONG
typedef DWORD * | LPDWORD
typedef void * | LPVOID
typedef const void * | LPCVOID
typedef int | INT
typedef unsigned int | UINT
typedef unsigned int * | PUINT
typedef unsigned char | byte
typedef long | LONG
typedef void * | HANDLE
typedef signed char | s8
typedef signed short | s16
typedef signed long | s32
typedef unsigned char | u8
typedef unsigned short | u16
typedef unsigned long | u32
typedef HWND__ * | HWND
typedef HINSTANCE__ * | HINSTANCE
typedef HMONITOR__ * | HMONITOR
typedef HINSTANCE | HMODULE
typedef deVec3f | deVertex
typedef deTexCoord2 | deTexCoord
## Enumerations
enum | deResult { deFAILED = 0, deSUCCEEDED, deCRITICALERROR, _deResult_Force32bit = 0x7fffffff }
## Functions
void | BREAK_EXECUTION ()
deColor | deMake_Color (deARGB in)
deARGB | deMake_Color (deColor &in)
deVec3d | deMake_Vec3d (deDouble x, deDouble y, deDouble z)
deVec3d | deMake_Vec3d (const deVertex &vec)
deVertex | deMake_Vertex (deFloat x, deFloat y, deFloat z)
deVertex | deMake_Vertex (const deVec3d &vec)
deTexCoord | deMake_TexCoord (deFloat u_, deFloat v_)
void | deMake_TexCoord (deTexCoord1 &target, const deTexCoord2 &tex2)
void | deMake_TexCoord (deTexCoord1 &target, const deTexCoord3 &tex3)
void | deMake_TexCoord (deTexCoord1 &target, const deTexCoord4 &tex4)
void | deMake_TexCoord (deTexCoord2 &target, const deTexCoord1 &tex1)
void | deMake_TexCoord (deTexCoord2 &target, const deTexCoord3 &tex3)
void | deMake_TexCoord (deTexCoord2 &target, const deTexCoord4 &tex4)
void | deMake_TexCoord (deTexCoord3 &target, const deTexCoord1 &tex1)
void | deMake_TexCoord (deTexCoord3 &target, const deTexCoord2 &tex2)
void | deMake_TexCoord (deTexCoord3 &target, const deTexCoord4 &tex4)
void | deMake_TexCoord (deTexCoord4 &target, const deTexCoord1 &tex1)
void | deMake_TexCoord (deTexCoord4 &target, const deTexCoord2 &tex2)
void | deMake_TexCoord (deTexCoord4 &target, const deTexCoord3 &tex3)
## Variables
const deBoolean | DE_TRUE = 1
const deBoolean | DE_FALSE = 0
const deDouble | DE_PI = (deDouble)3.14159265358979323846
const deDouble | DE_ONEOVERPI = (deDouble)0.318309886183790671
const deVec3d | deZeroVec = {0,0,0}
const deVec3d | deOneVec = {1,1,1}
const deVec3d | deVecX = {1,0,0}
const deVec3d | deVecY = {0,1,0}
const deVec3d | deVecZ = {0,0,1}
const deTexCoord | deZeroTex = {0,0}

## Detailed Description

Basic datatype definitions (Destiny-wide scope).

Author:
  Hootie

This file is the intellectual property of Novus Delta, LLC.. Usage of the contents of this file is subject to the Destiny3D Member License which can be found at http://www.destiny3d.com. Any other usage is prohibited.

This file is distributed "AS IS" without warranty of any kind. Novus Delta, LLC. does not guarantee the fitness of the contents of this file for any particular purpose.

Copyright (C) 2001-2003 Novus Delta, LLC. All Rights Reserved.

Change History

Date:
  Sept 2001

Author:
  Hootie

Remarks:
  Rearchitecture II

## Define Documentation

#define __DE_FILE__LINE__ __FILE__ "(" DESTRINGIZE_VALUE(__LINE__) "): "

#define _DEQUOTE | ( | x |  | ) | #x

#define _PRINT_NOTES

#define _TODO

#define ACOS acos

#define ARGB | ( | a,
|  | r,
|  | g,
|  | b |  | ) | ((DWORD)((((a)&0xff)<<24)|(((r)&0xff)<<16)|(((g)&0xff)<<8)|((b)&0xff)))

#define ASIN asin

#define ATAN atan

#define COS cos

#define DE3D_SAFE_DELETE | ( | p |  | ) | if(!p) {} else delete (p); (p)=NULL

#define DE3D_SAFE_DELETE_ARRAY | ( | p |  | ) | if(!p) {} else delete[] (p); (p)=NULL

#define DE3D_SAFE_RELEASE | ( | p |  | ) | if(!p) {} else (p)->Release(); (p)=NULL

#define DE_ASSERT | ( | exp |  | ) |

#define DE_DOUBLE_PRECISION (1)

#define DEBUG_EXP_RETURN | ( | exp,
|  | retval |  | ) |

#define DEBUG_EXP_RETURNMSG | ( | exp,
|  | retval,
|  | msg |  | ) |

#define DEBUG_ONLY | ( | exp |  | ) |

#define DEBUGMSG0 | ( | msg |  | ) |

#define DEBUGMSG1 | ( | fmt,
|  | arg1 |  | ) |

#define DEBUGMSG2 | ( | fmt,
|  | arg1,
|  | arg2 |  | ) |

#define DEBUGMSG3 | ( | fmt,
|  | arg1,
|  | arg2,
|  | arg3 |  | ) |

#define DEBUGMSG4 | ( | fmt,
|  | arg1,
|  | arg2,
|  | arg3,
|  | arg4 |  | ) |

#define DEBUGRETURN | ( | retval,
|  | message |  | ) | return retval

#define DEBUGRETURNNOVAL | ( | message |  | ) | return

#define deFALSE (DE_FALSE)

#define DEG2RAD | ( | d |  | ) | ((d)*(DE_PI/180.0))

#define DESTRINGIZE_VALUE | ( | x |  | ) | _DEQUOTE(x)

#define DETAILED_DEBUG_REPORT (1)

#define deTRUE (DE_TRUE)

#define deXOR | ( | x,
|  | y |  | ) | ( (!(x)&&(y)) || ((x)&&!(y)) )

#define FAR

#define fixme | ( | x |  | ) | message(__DE_FILE__LINE__ "FIXME: " #x "\n")

#define FIXME | ( | x |  | ) |

| Value:
    message(__DE_FILE__LINE__"\n"\
                "+--------------------------------\n"\
                "| FIXME: " #x                   "\n"\
                "+--------------------------------\n")

#define GrabARGB | ( | argb,
|  | a,
|  | r,
|  | g,
|  | b |  | ) | {a=((argb>>24)&0xff); r=((argb>>16)&0xff); g=((argb>>8)&0xff); b=((argb)&0xff); }

#define LEAK_HUNTING

#define max | ( | a,
|  | b |  | ) | (((a) > (b)) ? (a) : (b))

#define min | ( | a,
|  | b |  | ) | (((a) < (b)) ? (a) : (b))

#define note | ( | x |  | ) | message(__DE_FILE__LINE__ "NOTE: " #x "\n")

#define NOTIFY_BAD_RETURNS (1)

#define RAD2DEG | ( | r |  | ) | ((r)*(180*DE_ONEOVERPI))

#define SIN sin

#define TAN tan

#define todo | ( | x |  | ) | message(__DE_FILE__LINE__ "TODO: " #x "\n")

#define TODO | ( | x |  | ) |

| Value:
    message(__DE_FILE__LINE__"\n"\
                "+--------------------------------\n"\
                "| TODO : " #x                   "\n"\
                "+--------------------------------\n")

## Typedef Documentation

typedef int BOOL

typedef unsigned char byte

typedef byte BYTE

typedef unsigned long deARGB

typedef char deBoolean

typedef double deDouble

typedef float deFloat

typedef unsigned long deObjectID

typedef deTexCoord2 deTexCoord

typedef deVec3f deVertex

typedef unsigned short deWorldID

typedef unsigned long DWORD

typedef float FLOAT

typedef void* HANDLE

typedef struct HINSTANCE__* HINSTANCE

typedef HINSTANCE HMODULE

typedef struct HMONITOR__* HMONITOR

typedef struct HWND__* HWND

typedef int INT

typedef long LONG

typedef BOOL* LPBOOL

typedef BYTE* LPBYTE

typedef const void* LPCVOID

typedef DWORD* LPDWORD

typedef int* LPINT

typedef long* LPLONG

typedef void* LPVOID

typedef WORD* LPWORD

typedef FLOAT* PFLOAT

typedef unsigned int* PUINT

typedef signed short s16

typedef signed long s32

typedef signed char s8

typedef unsigned short u16

typedef unsigned long u32

typedef unsigned char u8

typedef unsigned int UINT

typedef unsigned short WORD

## Enumeration Type Documentation

enum deResult

  | Enumeration values:
  deFAILED |
  deSUCCEEDED |
  deCRITICALERROR |
  _deResult_Force32bit |

## Function Documentation

void BREAK_EXECUTION | ( |  | ) | `[inline, static]`

deARGB deMake_Color | ( | deColor & | in | ) | `[inline, static]`

deColor deMake_Color | ( | deARGB | in | ) | `[inline, static]`

void deMake_TexCoord | ( | deTexCoord4 & | target,
|  | const deTexCoord3 & | tex3
| ) | `[inline, static]`

void deMake_TexCoord | ( | deTexCoord4 & | target,
|  | const deTexCoord2 & | tex2
| ) | `[inline, static]`

void deMake_TexCoord | ( | deTexCoord4 & | target,
|  | const deTexCoord1 & | tex1
| ) | `[inline, static]`

void deMake_TexCoord | ( | deTexCoord3 & | target,
|  | const deTexCoord4 & | tex4
| ) | `[inline, static]`

void deMake_TexCoord | ( | deTexCoord3 & | target,
|  | const deTexCoord2 & | tex2
| ) | `[inline, static]`

void deMake_TexCoord | ( | deTexCoord3 & | target,
|  | const deTexCoord1 & | tex1
| ) | `[inline, static]`

void deMake_TexCoord | ( | deTexCoord2 & | target,
|  | const deTexCoord4 & | tex4
| ) | `[inline, static]`

void deMake_TexCoord | ( | deTexCoord2 & | target,
|  | const deTexCoord3 & | tex3
| ) | `[inline, static]`

void deMake_TexCoord | ( | deTexCoord2 & | target,
|  | const deTexCoord1 & | tex1
| ) | `[inline, static]`

void deMake_TexCoord | ( | deTexCoord1 & | target,
|  | const deTexCoord4 & | tex4
| ) | `[inline, static]`

void deMake_TexCoord | ( | deTexCoord1 & | target,
|  | const deTexCoord3 & | tex3
| ) | `[inline, static]`

void deMake_TexCoord | ( | deTexCoord1 & | target,
|  | const deTexCoord2 & | tex2
| ) | `[inline, static]`

deTexCoord deMake_TexCoord | ( | deFloat | u_,
|  | deFloat | v_
| ) | `[inline, static]`

deVec3d deMake_Vec3d | ( | const deVertex & | vec | ) | `[inline, static]`

deVec3d deMake_Vec3d | ( | deDouble | x,
|  | deDouble | y,
|  | deDouble | z
| ) | `[inline, static]`

deVertex deMake_Vertex | ( | const deVec3d & | vec | ) | `[inline, static]`

deVertex deMake_Vertex | ( | deFloat | x,
|  | deFloat | y,
|  | deFloat | z
| ) | `[inline, static]`

## Variable Documentation

const deBoolean DE_FALSE = 0

const deDouble DE_ONEOVERPI = (deDouble)0.318309886183790671

const deDouble DE_PI = (deDouble)3.14159265358979323846

const deBoolean DE_TRUE = 1

const deVec3d deOneVec = {1,1,1}

const deVec3d deVecX = {1,0,0}

const deVec3d deVecY = {0,1,0}

const deVec3d deVecZ = {0,0,1}

const deTexCoord deZeroTex = {0,0}

const deVec3d deZeroVec = {0,0,0}